package net.shadowfacts.asmr.program

import net.minecraft.util.Identifier
import net.minecraft.util.Language
import net.shadowfacts.cacao.geometry.Point

/**
 * @author shadowfacts
 */
abstract class ProgramBlock(val identifier: Identifier) {

	var position: Point = Point.ORIGIN

	abstract val inputs: Array<ProgramBlockInput<*>>
	abstract val outputs: Array<ProgramBlockOutput<*>>

	fun translateName(): String {
		return Language.getInstance().translate("programblock.${identifier.namespace}.${identifier.path}")
	}

}