package net.shadowfacts.asmr.program.execution

import net.minecraft.util.Identifier
import net.minecraft.util.Language

/**
 * @author shadowfacts
 */
class IncomingExecutionFlow(
		val identifier: Identifier,
		val block: ExecutableBlock
) {

	var source: OutgoingExecutionFlow? = null
		internal set

	fun link(from: OutgoingExecutionFlow) {
		from.link(to = this)
	}

	fun unlink() {
		source?.unlink()
	}

	fun translateName(): String {
		return Language.getInstance().translate("programblock.execution.${identifier.namespace}.${identifier.path}")
	}

}